# Purchase label with rate shopper Create a label using Rate Shopper to automatically select the best carrier and service based on the specified strategy. For more information about Rate Shopper strategies and use cases, see Rate Shopping. Endpoint: POST /v2/labels/rate_shopper_id/{rate_shopper_id} Version: 2.0.0 Security: api_keys ## Path parameters: - `rate_shopper_id` (string, required) The rate selection strategy. Determines which carrier and service will be automatically selected: - cheapest: Lowest cost option - fastest: Fastest option at the lowest price - best_value: Lowest cost option arriving within 4 days Enum: "cheapest", "fastest", "best_value" ## Request fields (application/json): - `shipment` (object, required) Shipment details. Must NOT include carrier_id, service_code, or shipping_rule_id as Rate Shopper selects these automatically. - `shipment.requested_shipment_service` (string,null) The requested shipment service Example: "usps_priority_mail" - `shipment.external_order_id` (string,null) ID that the Order Source assigned Example: "1232434" - `shipment.hold_until_date` (string,null) Date to hold the shipment until Example: "2025-01-15T00:00:00.000Z" - `shipment.ship_by_date` (string,null) Date by which the shipment should be shipped Example: "2025-01-15T00:00:00.000Z" - `shipment.retail_rate` (object,null) The retail rate for the shipment - `shipment.retail_rate.currency` (string, required) Currency code - `shipment.retail_rate.amount` (number, required) The monetary amount, in the specified currency. Example: 12 - `shipment.store_id` (string) The store ID associated with the shipment Example: "se-28529731" - `shipment.items` (array) Describe the packages included in this shipment as related to potential metadata that was imported from external order sources - `shipment.items.name` (string) item name Example: "box" - `shipment.items.sales_order_id` (string,null) sales order id Example: "12345" - `shipment.items.sales_order_item_id` (string,null) sales order item id Example: "1234556" - `shipment.items.quantity` (integer) The quantity of this item included in the shipment Example: 1 - `shipment.items.sku` (string,null) Item Stock Keeping Unit Example: "sku-1234" - `shipment.items.bundle_sku` (string,null) Bundle SKU for the item Example: "bundle-123" - `shipment.items.external_order_id` (string,null) external order id Example: "123445" - `shipment.items.external_order_item_id` (string,null) external order item id Example: "12" - `shipment.items.asin` (string,null) Amazon Standard Identification Number Example: "B00005N5PF" - `shipment.items.order_source_code` (string) The order sources that are supported by ShipStation Enum: "amazon_ca", "amazon_us", "brightpearl", "channel_advisor", "cratejoy", "ebay", "etsy", "jane", "groupon_goods", "magento", "paypal", "seller_active", "shopify", "stitch_labs", "squarespace", "three_dcart", "tophatter", "walmart", "woo_commerce", "volusion" - `shipment.items.item_id` (string,null) Unique identifier for the item Example: "1402291169813" - `shipment.items.allocation_status` (string,null) Allocation status of the item Example: "allocated" - `shipment.items.image_url` (string,null) URL to the item image Example: "https://example.com/image.jpg" - `shipment.items.weight` (object) Weight of the individual item - `shipment.items.weight.value` (number, required) The weight, in the specified unit Example: 23 - `shipment.items.weight.unit` (string, required) Weight unit Enum: "pound", "ounce", "gram", "kilogram" - `shipment.items.unit_price` (number,null) Unit price of the item Example: 88 - `shipment.items.tax_amount` (number,null) Tax amount for the item Example: 5.5 - `shipment.items.shipping_amount` (number,null) Shipping amount for the item Example: 10 - `shipment.items.inventory_location` (string,null) Inventory location of the item Example: "warehouse-a" - `shipment.items.options` (array) Item options/variants - `shipment.items.options.name` (string) Option name Example: "Color" - `shipment.items.options.value` (string) Option value Example: "Red" - `shipment.items.product_id` (string,null) Product ID Example: "10408926" - `shipment.items.fullfilment_sku` (string,null) Fulfillment SKU Example: "fulfill-123" - `shipment.items.upc` (string,null) Universal Product Code Example: "123456789012" - `shipment.notes_from_buyer` (string,null) Notes from the buyer Example: "Please handle with care" - `shipment.notes_for_gift` (string,null) Gift notes Example: "Happy Birthday!" - `shipment.is_gift` (boolean) Indicates if the shipment is a gift Example: true - `shipment.assigned_user` (string,null) User assigned to the shipment Example: "user@example.com" - `shipment.amount_paid` (object) Total amount paid for the order - `shipment.shipping_paid` (object) Amount paid for shipping - `shipment.tax_paid` (object) Amount paid for taxes - `shipment.zone` (integer,null) Shipping zone Example: 1 - `shipment.display_scheme` (string,null) Display scheme for the shipment Example: "label" - `shipment.tax_identifiers` (array,null) - `shipment.tax_identifiers.taxable_entity_type` (string, required) The taxable entity type for this tax item. Valid values include the following |Value |Description |:--------- |:----------------------------------------------------- |shipper | The shipper is responsible for this tax. |recipient | The recipient of the shipment is responsible for this tax. |ior | The importer of records is responsible for tax. Enum: "shipper", "recipient", "ior" - `shipment.tax_identifiers.identifier_type` (string, required) Tax identifier type for customs declaration |Pickup Type | Description |---------------|----------------------------------------- |vat | The tax identifier is a Value Added Tax. |eori | The tax identifier is an Economic Operators Registration and Identification Number (EORI). |ssn | The tax identifier is a Social Security Number. |ein | The tax identifier is an Employer Identification Number (EIN). |tin | The tax identifier is a Tax Identification Number (TIN). |ioss | The tax identifier is an Import One-Stop Shop (IOSS). |pan | The tax identifier is a Permanent Account Number (PAN). |voec | The tax identifier is a Norwegian VAT On E-Commerce(VOEC). |pccc | The tax identifier is a Personal Customs Clearance Code (PCCC). |oss | The tax identifier is an One-Stop Shop (OSS). |passport | The tax identifier is a Passport Number. |abn | The tax identifier is an Australian Business Number. |ukims | The tax identifier is an UK Internal Market Scheme number. Enum: "vat", "eori", "ssn", "ein", "tin", "ioss", "pan", "voec", "pccc", "oss", "passport", "abn", "ukims" - `shipment.tax_identifiers.issuing_authority` (string, required) The authority that issued this tax. This must be a valid 2 character ISO 3166 Alpha 2 country code. Example: "US" - `shipment.tax_identifiers.value` (string, required) The value of the identifier Example: "value" - `shipment.external_shipment_id` (string,null) A unique user-defined key to identify a shipment. This can be used to retrieve the shipment. > Warning: The external_shipment_id is limited to 50 characters. Any additional characters will be truncated. Example: "1234556" - `shipment.shipment_number` (string,null) A non-unique user-defined number used to identify a shipment. If undefined, this will match the external_shipment_id of the shipment. > Warning: The shipment_number is limited to 50 characters. Any additional characters will be truncated. Example: "10001" - `shipment.ship_date` (string,null) The date that the shipment was (or will be) shippped. ShipStation will take the day of week into consideration. For example, if the carrier does not operate on Sundays, then a package that would have shipped on Sunday will ship on Monday instead. Example: "2018-09-23T00:00:00Z" - `shipment.ship_to` (object) The recipient's mailing address - `shipment.ship_to.name` (string, required) The name of a contact person at this address. This field may be set instead of - or in addition to - the company_name field. Example: "John Doe" - `shipment.ship_to.phone` (string, required) The phone number of a contact person at this address. The format of this phone number varies depending on the country. Example: "+1 204-253-9411 ext. 123" - `shipment.ship_to.email` (string,null) Email for the address owner. Example: "example@example.com" - `shipment.ship_to.company_name` (string,null) If this is a business address, then the company name should be specified here. Example: "The Home Depot" - `shipment.ship_to.address_line1` (string, required) The first line of the street address. For some addresses, this may be the only line. Other addresses may require 2 or 3 lines. Example: "1999 Bishop Grandin Blvd." - `shipment.ship_to.address_line2` (string,null) The second line of the street address. For some addresses, this line may not be needed. Example: "Unit 408" - `shipment.ship_to.address_line3` (string,null) The third line of the street address. For some addresses, this line may not be needed. Example: "Building #7" - `shipment.ship_to.city_locality` (string, required) The name of the city or locality Example: "Winnipeg" - `shipment.ship_to.state_province` (string, required) The state or province. For some countries (including the U.S.) only abbreviations are allowed. Other countries allow the full name or abbreviation. Example: "Manitoba" - `shipment.ship_to.postal_code` (string, required) postal code Example: "78756-3717" - `shipment.ship_to.country_code` (string, required) The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1) Example: "CA" - `shipment.ship_to.address_residential_indicator` (string, required) Indicates whether this is a residential address. Enum: "unknown", "yes", "no" - `shipment.ship_to.instructions` (string,null) Additional text about how to handle the shipment at this address. Example: "any instruction" - `shipment.ship_to.geolocation` (array) - `shipment.ship_to.geolocation.type` (string) Enum of available type of geolocation items: - 'what3words' functionality allows to specify a location by providing 3 words that have been assign to the specific location see [link](https://what3words.com/business) for more details. Enum: "what3words" - `shipment.ship_to.geolocation.value` (string) value of the geolocation item Example: "cats.with.thumbs" - `shipment.ship_from` (object) The shipment's origin address. If you frequently ship from the same location, consider [creating a warehouse]. Then you can simply specify the warehouse_id rather than the complete address each time. - `shipment.warehouse_id` (string,null) The [warehouse] that the shipment is being shipped from. Either warehouse_id or ship_from must be specified. Example: "se-28529731" - `shipment.return_to` (object) The return address for this shipment. Defaults to the ship_from address. Can be sent with a warehouse_id, in which case the return address can be overridden. This allows you to have a different address printed on the label while maintaining the origin address. - `shipment.is_return` (boolean,null) An optional indicator if the shipment is intended to be a return. Defaults to false if not provided. Example: true - `shipment.confirmation` (string) The type of delivery confirmation that is required for this shipment Enum: "none", "delivery", "signature", "adult_signature", "direct_signature", "delivery_mailed", "verbal_confirmation", "delivery_code", "age_verification_16_plus" - `shipment.customs` (object,null) Customs information. This is usually only needed for international shipments. - `shipment.customs.contents` (string, required) The type of contents in this shipment. This may impact import duties or customs treatment. Enum: "merchandise", "documents", "gift", "returned_goods", "sample", "other" - `shipment.customs.contents_explanation` (string) Explanation for contents (required if the contents is provided as other) Example: "rubber duckies" - `shipment.customs.non_delivery` (string, required) Indicates what to do if a package is unable to be delivered. Enum: "return_to_sender", "treat_as_abandoned" - `shipment.customs.terms_of_trade_code` (string) Specifies the supported terms of trade code (incoterms) Enum: "exw", "fca", "cpt", "cip", "dpu", "dap", "ddp", "fas", "fob", "cfr", "cif", "ddu", "daf", "deq", "des" - `shipment.customs.declaration` (string) Declaration statement to be placed on the commercial invoice Example: "I hereby certify that the information on this invoice is true and correct and that the contents and value of this shipment are as stated above" - `shipment.customs.invoice_additional_details` (object) The additional information to put on commercial invoice - `shipment.customs.invoice_additional_details.freight_charge` (object) Freight Charge for shipment. - `shipment.customs.invoice_additional_details.insurance_charge` (object) Insurance Charge for shipment. - `shipment.customs.invoice_additional_details.discount` (object) Discount for shipment. - `shipment.customs.invoice_additional_details.estimated_import_charges` (object) Estimated import charges for commercial invoices for international shipments. - `shipment.customs.invoice_additional_details.estimated_import_charges.taxes` (object) Estimated import taxes. - `shipment.customs.invoice_additional_details.estimated_import_charges.duties` (object) Estimated import duties. - `shipment.customs.invoice_additional_details.other_charge` (object) Other charge for shipment. - `shipment.customs.invoice_additional_details.other_charge_description` (string) Description for the other charge (if provided). Example: "Other charges description" - `shipment.customs.importer_of_record` (object) importer of records address, anywhere in the world. - `shipment.customs.importer_of_record.name` (string, required) The name of a contact person at this address. Either name or the company_name field should always be set. Example: "John Doe" - `shipment.customs.importer_of_record.company_name` (string,null) If this is a business address, then the company name should be specified here. Either name or the company_name field should always be set. Example: "The Home Depot" - `shipment.customs.customs_items` (array) Customs declarations for each item in the shipment. (Please provide this information under products inside packages) - `shipment.customs.customs_items.description` (string,null) A description of the item Example: "This is a description" - `shipment.customs.customs_items.quantity` (integer) The quantity of this item in the shipment. Example: 1 - `shipment.customs.customs_items.value` (number) The monetary amount, in the specified currency. Example: 12 - `shipment.customs.customs_items.value_currency` (string) The currencies that are supported by ShipStation are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html Example: "USD" - `shipment.customs.customs_items.weight` (object) The item weight - `shipment.customs.customs_items.harmonized_tariff_code` (string,null) The [Harmonized Tariff Code](https://en.wikipedia.org/wiki/Harmonized_System) of this item. Example: "3926.10" - `shipment.customs.customs_items.country_of_origin` (string,null) The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1) where this item originated Example: "CA" - `shipment.customs.customs_items.unit_of_measure` (string,null) Example: "pound" - `shipment.customs.customs_items.sku` (string,null) The SKU (Stock Keeping Unit) of the customs item Example: "sku-1234" - `shipment.customs.customs_items.sku_description` (string,null) Description of the Custom Item's SKU Example: "this is a description" - `shipment.advanced_options` (object) Advanced shipment options. These are entirely optional. - `shipment.advanced_options.bill_to_account` (string,null) This field is used to [bill shipping costs to a third party]. This field must be used in conjunction with the bill_to_country_code, bill_to_party, and bill_to_postal_code fields. Example: "123456789" - `shipment.advanced_options.bill_to_country_code` (string,null) The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1) of the third-party that is responsible for shipping costs. Example: "CA" - `shipment.advanced_options.bill_to_party` (string,null) Indicates whether to bill shipping costs to the recipient or to a third-party. When billing to a third-party, the bill_to_account, bill_to_country_code, and bill_to_postal_code fields must also be set. Enum: "recipient", "third_party" - `shipment.advanced_options.bill_to_postal_code` (string,null) The postal code of the third-party that is responsible for shipping costs. Example: "28005" - `shipment.advanced_options.contains_alcohol` (boolean) Indicates that the shipment contains alcohol. Example: true - `shipment.advanced_options.delivered_duty_paid` (boolean) Indicates that the shipper is paying the international delivery duties for this shipment. This option is supported by UPS, FedEx, and DHL Express. Example: true - `shipment.advanced_options.dry_ice` (boolean) Indicates if the shipment contain dry ice Example: true - `shipment.advanced_options.dry_ice_weight` (object,null) The weight of the dry ice in the shipment - `shipment.advanced_options.non_machinable` (boolean) Indicates that the package cannot be processed automatically because it is too large or irregularly shaped. This is primarily for USPS shipments. See [Section 1.2 of the USPS parcel standards](https://pe.usps.com/text/dmm300/101.htm#ep1047495) for details. Example: true - `shipment.advanced_options.saturday_delivery` (boolean) Enables Saturday delivery, if supported by the carrier. Example: true - `shipment.advanced_options.fedex_freight` (object) Provide details for the Fedex freight service - `shipment.advanced_options.fedex_freight.shipper_load_and_count` (string) Example: "shipper_load_and_count" - `shipment.advanced_options.fedex_freight.booking_confirmation` (string) Example: "today" - `shipment.advanced_options.use_ups_ground_freight_pricing` (boolean,null) Whether to use [UPS Ground Freight pricing] If enabled, then a freight_class must also be specified. Example: true - `shipment.advanced_options.freight_class` (string,null) The National Motor Freight Traffic Association [freight class](http://www.nmfta.org/pages/nmfc?AspxAutoDetectCookieSupport=1), such as "77.5", "110", or "250". Example: "77.5" - `shipment.advanced_options.custom_field1` (string,null) An arbitrary field that can be used to store information about the shipment. Example: "custom field 1" - `shipment.advanced_options.custom_field2` (string,null) An arbitrary field that can be used to store information about the shipment. Example: "custom field 2" - `shipment.advanced_options.custom_field3` (string,null) An arbitrary field that can be used to store information about the shipment. Example: "custom field 3" - `shipment.advanced_options.origin_type` (string,null) Indicates if the package will be picked up or dropped off by the carrier Enum: "pickup", "drop_off" - `shipment.advanced_options.additional_handling` (boolean,null) Indicate to the carrier that this shipment requires additional handling. Example: true - `shipment.advanced_options.shipper_release` (boolean,null) Example: true - `shipment.advanced_options.collect_on_delivery` (object) Defer payment until package is delivered, instead of when it is ordered. - `shipment.advanced_options.collect_on_delivery.payment_type` (string) Types of payment that are supported Enum: "any", "cash", "cash_equivalent", "none" - `shipment.advanced_options.collect_on_delivery.payment_amount` (object) - `shipment.advanced_options.collect_on_delivery.payment_amount.currency` (string) The currencies that are supported by ShipStation are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html Example: "USD" - `shipment.advanced_options.collect_on_delivery.payment_amount.amount` (number) Example: 12 - `shipment.advanced_options.third_party_consignee` (boolean) Third Party Consignee option is a value-added service that allows the shipper to supply goods without commercial invoices being attached Example: true - `shipment.advanced_options.dangerous_goods` (boolean) Indicates if the Dangerous goods are present in the shipment Example: true - `shipment.advanced_options.dangerous_goods_contact` (object) Contact information for Dangerous goods - `shipment.advanced_options.dangerous_goods_contact.name` (string) Name of the contact Example: "Michael Robinson" - `shipment.advanced_options.dangerous_goods_contact.phone` (string) Phone number of the contact Example: "123456578789" - `shipment.advanced_options.windsor_framework_details` (object) The Windsor framework is a new regulation in the UK that simplifies customs procedures for goods moved from the UK mainland to Northern Ireland. - `shipment.advanced_options.windsor_framework_details.movement_indicator` (string) An indicator that will tell the carrier and HMRC the type of movement for the shipment. Enum: "c2c", "b2c", "c2b", "b2b" - `shipment.advanced_options.windsor_framework_details.not_at_risk` (boolean) An indicator that allows a shipper to declare the shipment as not-at-risk. Example: true - `shipment.advanced_options.ancillary_endorsements_option` (string,null) Ancillary endorsements option for the shipment Example: "forward" - `shipment.advanced_options.return_pickup_attempts` (integer,null) Number of return pickup attempts Example: 3 - `shipment.advanced_options.own_document_upload` (boolean) Indicates if own document upload is enabled - `shipment.advanced_options.limited_quantity` (boolean) Indicates if the shipment contains limited quantities - `shipment.advanced_options.event_notification` (boolean) Indicates if event notifications are enabled - `shipment.advanced_options.delivery_as_addressed` (boolean) Instructs the carrier to deliver the package only to the exact address provided - `shipment.advanced_options.return_after_first_attempt` (boolean) Ensures the shipment is immediately flagged for return to the sender if the initial delivery attempt fails - `shipment.insurance_provider` (string) The insurance provider to use for any insured packages in the shipment. Enum: "none", "shipsurance", "carrier", "third_party" - `shipment.tags` (array) Arbitrary tags associated with this shipment. Tags can be used to categorize shipments, and shipments can be queried by their tags. Note: Tags require object structure with name property, not simple strings. - `shipment.tags.name` (string, required) The tag name. Example: "Fragile" - `shipment.packages` (array) The packages in the shipment. > Note: Some carriers only allow one package per shipment. If you attempt to create a multi-package shipment for a carrier that doesn't allow it, an error will be returned. - `shipment.packages.package_id` (string) A string that uniquely identifies this [package type] Example: "se-28529731" - `shipment.packages.package_code` (string) The [package type] such as thick_envelope, small_flat_rate_box, large_package, etc. The code package indicates a custom or unknown package type. Example: "small_flat_rate_box" - `shipment.packages.package_name` (string) The name of the of the [package type] Example: "Flat Rate Envelope" - `shipment.packages.weight` (object, required) The package weight - `shipment.packages.dimensions` (object) The package dimensions - `shipment.packages.dimensions.unit` (string, required) Dimension unit Enum: "inch", "centimeter" - `shipment.packages.dimensions.length` (number, required) The length of the package, in the specified unit Example: 2 - `shipment.packages.dimensions.width` (number, required) The width of the package, in the specified unit Example: 2 - `shipment.packages.dimensions.height` (number, required) The height of the package, in the specified unit Example: 1 - `shipment.packages.insured_value` (object) The insured value of the package. Requires the insurance_provider field of the shipment to be set. - `shipment.packages.label_messages` (object) Custom messages to print on the shipping label for the package. These are typically used to print invoice numbers, product numbers, or other internal reference numbers. Not all carriers support label messages. The number of lines and the maximum length of each line also varies by carrier. |Carrier |Max lines |Max line length |-------------------|----------|-------------------- |USPS (Stamps.com) |3 |60 |FedEx |3 |35 for the first line. 30 for additional lines. |UPS |2 |35 |OnTrac |2 |25 - `shipment.packages.label_messages.reference1` (string,null, required) The first line of the custom label message. Some carriers may prefix this line with something like "REF", "Reference", "Trx Ref No.", etc. Example: "Reference" - `shipment.packages.label_messages.reference2` (string,null, required) The second line of the custom label message. Some carriers may prefix this line with something like "INV", "Reference 2", "Trx Ref No.", etc. Example: "Reference 2" - `shipment.packages.label_messages.reference3` (string,null, required) The third line of the custom label message. Some carriers may prefix this line with something like "PO", "Reference 3", etc. Example: "Reference 3" - `shipment.packages.external_package_id` (string) An external package id. Example: "se-1234545" - `shipment.packages.content_description` (string,null) A short description of the package content. Required for shipments moving to, from, and through Mexico. Example: "Hand knitted wool socks" - `shipment.packages.products` (array) Details about products inside packages (Information provided would be used on custom documentation) - `shipment.packages.products.value` (object) The declared value of each item - `shipment.packages.products.sku` (string,null) The SKU (Stock Keeping Unit) of the item Example: "sku-1223344" - `shipment.packages.products.mid_code` (string,null) Manufacturers Identification code Example: "GBCOM15BRI" - `shipment.packages.products.product_url` (string,null) link to the item on the seller website Example: "https://myproduct.com" - `shipment.packages.products.vat_rate` (number,null) VAT rate applicable to the item Example: 0.2 - `shipment.packages.products.dangerous_goods` (array) Details about dangerous goods inside products - `shipment.packages.products.dangerous_goods.id_number` (string,null) UN number to identify the dangerous goods. Example: "1234r1" - `shipment.packages.products.dangerous_goods.shipping_name` (string,null) Trade description of the dangerous goods. Example: "things with dangerous goods" - `shipment.packages.products.dangerous_goods.technical_name` (string,null) Recognized Technical or chemical name of dangerous goods. Example: "chloric acid" - `shipment.packages.products.dangerous_goods.product_class` (string,null) Dangerous goods product class based on regulation. Example: "1987" - `shipment.packages.products.dangerous_goods.product_class_subsidiary` (string,null) A secondary of product class for substances presenting more than one particular hazard Example: "1987" - `shipment.packages.products.dangerous_goods.packaging_group` (string) Enum: "i", "ii", "iii" - `shipment.packages.products.dangerous_goods.dangerous_amount` (object) This model represents the amount of the dangerous goods. - `shipment.packages.products.dangerous_goods.dangerous_amount.amount` (number) The amount of dangerous goods. Example: 12 - `shipment.packages.products.dangerous_goods.dangerous_amount.unit` (string,null) The unit of dangerous goods. Example: "GBP" - `shipment.packages.products.dangerous_goods.quantity` (integer) Quantity of dangerous goods. Example: 1 - `shipment.packages.products.dangerous_goods.packaging_instruction` (string,null) The specific standardized packaging instructions from the relevant regulatory agency that have been applied to the parcel/container. Example: "Packaging materials and containers that are in contact with food products must comply with the provisions established by Regulation " - `shipment.packages.products.dangerous_goods.packaging_instruction_section` (string) Enum: "section_1", "section_2", "section_1a", "section_1b" - `shipment.packages.products.dangerous_goods.packaging_type` (string,null) The type of exterior packaging used to contain the dangerous good. Example: "X" - `shipment.packages.products.dangerous_goods.transport_mean` (string) Enum: "ground", "water", "cargo_aircraft_only", "passenger_aircraft" - `shipment.packages.products.dangerous_goods.transport_category` (string,null) Transport category assign to dangerous goods for the transport purpose. Example: "6.1" - `shipment.packages.products.dangerous_goods.regulation_authority` (string,null) Name of the regulatory authority. Example: "AEAT" - `shipment.packages.products.dangerous_goods.regulation_level` (string) Enum: "lightly_regulated", "fully_regulated", "limited_quantities", "excepted_quantity" - `shipment.packages.products.dangerous_goods.radioactive` (boolean,null) Indication if the substance is radioactive. - `shipment.packages.products.dangerous_goods.reportable_quantity` (boolean,null) Indication if the substance needs to be reported to regulatory authority based on the quantity. - `shipment.packages.products.dangerous_goods.tunnel_code` (string,null) Defines which types of tunnels the shipment is allowed to go through Example: "all" - `shipment.packages.products.dangerous_goods.additional_description` (string,null) Provider additonal description regarding the dangerous goods. This is used as a placed holder to provider additional context and varies by carrier Example: "any description" - `shipment.comparison_rate_type` (string,null) Calculate a rate for this shipment with the requested carrier using a ratecard that differs from the default. Only supported for UPS and USPS. Example: "retail" - `label_format` (string) The possible file formats in which shipping labels can be downloaded. We recommend pdf format because it is supported by all carriers, whereas some carriers do not support the png or zpl formats. |Label Format | Supported Carriers |--------------|----------------------------------- |pdf | All carriers |png | fedex stamps_com ups usps |zpl | access_worldwide apc asendia dhl_global_mail dhl_express dhl_express_australia dhl_express_canada dhl_express_worldwide dhl_express_uk dpd endicia fedex fedex_uk firstmile imex newgistics ontrac rr_donnelley stamps_com ups usps Enum: "pdf", "png", "zpl" - `label_layout` (string) The available layouts (sizes) in which shipping labels can be downloaded. The label format determines which sizes are supported. 4x6 is supported for all label formats, whereas letter (8.5" x 11") is only supported for pdf format. Enum: "4x6", "letter" - `display_scheme` (string) The display format that the label should be shown in. Enum: "label", "qr_code", "label_and_qr_code", "paperless", "label_and_paperless" - `label_download_type` (string) Specifies how the label should be downloaded. - url: Returns URLs to download the label - inline: Returns the label data inline in the response Enum: "url", "inline" ## Response 200 fields (application/json): - `rate_shopper_id` (string) The Rate Shopper strategy used to create this label Enum: "cheapest", "fastest", "best_value" - `label_id` (string) A string that uniquely identifies the label. This ID is generated by ShipStation when the label is created. Example: "se-28529731" - `status` (string) The possible statuses that a [shipping label] can be in. |Status |Description |:------------|:----------------------------------------------------- |processing |When labels are created in a [batch], it may take a few minutes for all of the labels in the batch to be created. During this period, they will be in processing status. |completed |The label was successfully created |error |The label could not be created due to an error, such as an invalid delivery address |voided |The label has been [voided] Enum: "processing", "completed", "error", "voided" - `shipment_id` (string) The shipment that this label is for. ShipStation can create a shipment for you automatically when you [create a label], or you can [create your own shipment] and then [use it to print a label] Example: "se-28529731" - `external_shipment_id` (string,null) A unique user-defined key to identify a shipment. This can be used to retrieve the shipment. > Warning: The external_shipment_id is limited to 50 characters. Any additional characters will be truncated. Example: "externalId-1234556" - `external_order_id` (string,null) ID that the Order Source assigned Example: "externalOrderId-1232434" - `ship_date` (string) The date that the package was (or will be) shippped. ShipStation will take the day of week into consideration. For example, if the carrier does not operate on Sundays, then a package that would have shipped on Sunday will ship on Monday instead. Example: "2018-09-23T00:00:00Z" - `created_at` (string) The date and time that the label was created in ShipStation . Example: "2018-09-23T15:00:00.000Z" - `shipment_cost` (object) The cost of shipping, delivery confirmation, and other carrier charges. This amount does not include insurance costs. - `shipment_cost.currency` (string, required) Currency code - `shipment_cost.amount` (number, required) The monetary amount, in the specified currency. Example: 12 - `insurance_cost` (object) The insurance cost for this package. Add this to the shipment_cost field to get the total cost. - `requested_comparison_amount` (object) The total shipping cost for the specified comparison_rate_type. - `tracking_number` (string) The tracking number for the package. Tracking number formats vary across carriers. Example: "782758401696" - `is_return_label` (boolean) Indicates whether this is a return label. You may also want to set the rma_number so you know what is being returned. Example: true - `rma_number` (string,null) An optional Return Merchandise Authorization number. This field is useful for return labels. You can set it to any string value. Example: "asd12323" - `is_international` (boolean) Indicates whether this is an international shipment. That is, the originating country and destination country are different. Example: true - `batch_id` (string) If this label was created as part of a [batch], then this is the unique ID of that batch. Example: "se-28529731" - `carrier_id` (string) The unique ID of the [carrier account] that was used to create this label Example: "se-28529731" - `charge_event` (string) The label charge event. Enum: "carrier_default", "on_creation", "on_carrier_acceptance" - `service_code` (string) The [carrier service] used to ship the package, such as fedex_ground, usps_first_class_mail, flat_rate_envelope, etc. Example: "usps_first_class_mail" - `package_code` (string) The [package type], such as thick_envelope, small_flat_rate_box, large_package, etc. The code package indicates a custom or unknown package type. Example: "small_flat_rate_box" - `voided` (boolean) Indicates whether the label has been [voided] Example: true - `voided_at` (string,null) The date and time that the label was [voided] , or null if the label has not been voided Example: "2018-09-23T15:00:00.000Z" - `label_format` (string) The file format that you want the label to be in. We recommend pdf format because it is supported by all carriers, whereas some carriers do not support the png or zpl formats. Enum: "pdf", "png", "zpl" - `display_scheme` (string) The display format that the label should be shown in. Enum: "label", "qr_code", "label_and_qr_code", "paperless", "label_and_paperless" - `label_layout` (string) The layout (size) that you want the label to be in. The label_format determines which sizes are allowed. 4x6 is supported for all label formats, whereas letter (8.5" x 11") is only supported for pdf format. Enum: "4x6", "letter" - `trackable` (boolean) Indicates whether the shipment is trackable, in which case the tracking_status field will reflect the current status and each package will have a tracking_number. Example: true - `label_image_id` (string,null) The label image resource that was used to create a custom label image. Example: "img_DtBXupDBxREpHnwEXhTfgK" - `carrier_code` (string) The [shipping carrier] who will ship the package, such as fedex, dhl_express, stamps_com, etc. Example: "dhl_express" - `confirmation` (string) The type of delivery confirmation that is required for this shipment. Enum: "none", "delivery", "signature", "adult_signature", "direct_signature", "delivery_mailed", "verbal_confirmation", "delivery_code", "age_verification_16_plus" - `tracking_status` (string) The current status of the package, such as in_transit or delivered Enum: "unknown", "in_transit", "error", "delivered" - `label_download` (object) Reference to the various downloadable file formats for the generated label - `label_download.href` (string) The URL of the linked resource, if any Example: "http://api.shipstation.com/v2/labels/se-28529731" - `label_download.pdf` (string) The URL for the pdf generated label Example: "http://api.shipstation.com/v2/labels/se-28529731" - `label_download.png` (string) The URL for the png generated label Example: "http://api.shipstation.com/v2/labels/se-28529731" - `label_download.zpl` (string) The URL for the zpl generated label Example: "http://api.shipstation.com/v2/labels/se-28529731" - `form_download` (object,null) The link to download the customs form (a.k.a. commercial invoice) for this shipment, if any. Forms are in PDF format. This field is null if the shipment does not require a customs form, or if the carrier does not support it. - `form_download.type` (string) The type of resource, or the type of relationship to the parent resource Example: "child" - `qr_code_download` (object,null) The QR code download for the package - `paperless_download` (object,null) The paperless details which may contain elements like href, instructions and handoff_code. - `paperless_download.instructions` (string,null) The instructions for the paperless download. Example: "any instructions" - `paperless_download.handoff_code` (string,null) The handoff code for the paperless download. Example: "122334" - `insurance_claim` (object,null) The link to submit an insurance claim for the shipment. This field is null if the shipment is not insured or if the insurance provider does not support online claim submission. - `packages` (array) The label's package(s). > Note: Some carriers only allow one package per label. If you attempt to create a multi-package label for a carrier that doesn't allow it, an error will be returned. - `packages.package_id` (integer) The shipment package id Example: 1234545 - `packages.weight` (object, required) The package weight - `packages.weight.value` (number, required) The weight, in the specified unit Example: 23 - `packages.weight.unit` (string, required) Weight unit Enum: "pound", "ounce", "gram", "kilogram" - `packages.dimensions` (object) The package dimensions - `packages.dimensions.unit` (string, required) Dimension unit Enum: "inch", "centimeter" - `packages.dimensions.length` (number, required) The length of the package, in the specified unit Example: 2 - `packages.dimensions.width` (number, required) The width of the package, in the specified unit Example: 2 - `packages.dimensions.height` (number, required) The height of the package, in the specified unit Example: 1 - `packages.insured_value` (object) The insured value of the package. Requires the insurance_provider field of the shipment to be set. - `packages.tracking_number` (string) The tracking number for the package. The format depends on the carrier. Example: "1Z932R800392060079" - `packages.label_download` (object) The label download for the package - `packages.form_download` (object) The form download for any customs that are needed - `packages.label_messages` (object) Custom messages to print on the shipping label for the package. These are typically used to print invoice numbers, product numbers, or other internal reference numbers. Not all carriers support label messages. The number of lines and the maximum length of each line also varies by carrier. |Carrier |Max lines |Max line length |-------------------|----------|-------------------- |USPS (Stamps.com) |3 |60 |FedEx |3 |35 for the first line. 30 for additional lines. |UPS |2 |35 |OnTrac |2 |25 - `packages.label_messages.reference1` (string,null, required) The first line of the custom label message. Some carriers may prefix this line with something like "REF", "Reference", "Trx Ref No.", etc. Example: "Reference" - `packages.label_messages.reference2` (string,null, required) The second line of the custom label message. Some carriers may prefix this line with something like "INV", "Reference 2", "Trx Ref No.", etc. Example: "Reference 2" - `packages.label_messages.reference3` (string,null, required) The third line of the custom label message. Some carriers may prefix this line with something like "PO", "Reference 3", etc. Example: "Reference 3" - `packages.external_package_id` (string) An external package id. Example: "se-1234567" - `packages.content_description` (string,null) A short description of the package content. Required for shipments moving to, from, and through Mexico. Example: "Hand knitted wool socks" - `packages.sequence` (integer) Package sequence Example: 34 - `packages.has_label_documents` (boolean) Whether the package has label documents available for download Example: true - `packages.has_form_documents` (boolean) Whether the package has form documents available for download Example: true - `packages.has_qr_code_documents` (boolean) Whether the package has QR code documents available for download Example: true - `packages.has_paperless_label_documents` (boolean) Whether the package has paperless documents available for download Example: true - `packages.alternative_identifiers` (array,null) Alternative identifiers associated with this package. - `packages.alternative_identifiers.type` (string) The type of alternative_identifier that corresponds to the value. Example: "last_mile_tracking_number" - `packages.alternative_identifiers.value` (string) The value of the alternative_identifier. Example: "12345678912345678912" - `alternative_identifiers` (array,null) Additional information some carriers may provide by which to identify a given label in their system. - `rate_details` (array) - `rate_details.rate_detail_type` (string) Example: "shipping" - `rate_details.carrier_description` (string) Example: "Shipping" - `rate_details.carrier_billing_code` (string) Example: "shipping" - `rate_details.carrier_memo` (string) - `rate_details.amount` (object) A monetary value, such as the price of a shipping label, the insured value of a package, or an account balance. - `rate_details.billing_source` (string) Example: "carrier" - `tracking_url` (string,null) The URL to track the package. This URL is provided by the carrier and is unique to the tracking number. Example: "https://www.fedex.com/fedextrack/?action=track&trackingnumber=1234" - `ship_to` (object) The recipient's mailing address - `ship_to.name` (string, required) The name of a contact person at this address. This field may be set instead of - or in addition to - the company_name field. Example: "John Doe" - `ship_to.phone` (string, required) The phone number of a contact person at this address. The format of this phone number varies depending on the country. Example: "+1 204-253-9411 ext. 123" - `ship_to.email` (string,null) Email for the address owner. Example: "example@example.com" - `ship_to.company_name` (string,null) If this is a business address, then the company name should be specified here. Example: "The Home Depot" - `ship_to.address_line1` (string, required) The first line of the street address. For some addresses, this may be the only line. Other addresses may require 2 or 3 lines. Example: "1999 Bishop Grandin Blvd." - `ship_to.address_line2` (string,null) The second line of the street address. For some addresses, this line may not be needed. Example: "Unit 408" - `ship_to.address_line3` (string,null) The third line of the street address. For some addresses, this line may not be needed. Example: "Building #7" - `ship_to.city_locality` (string, required) The name of the city or locality Example: "Winnipeg" - `ship_to.state_province` (string, required) The state or province. For some countries (including the U.S.) only abbreviations are allowed. Other countries allow the full name or abbreviation. Example: "Manitoba" - `ship_to.postal_code` (string, required) postal code Example: "78756-3717" - `ship_to.country_code` (string, required) The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1) Example: "CA" - `ship_to.address_residential_indicator` (string, required) Indicates whether this is a residential address. Enum: "unknown", "yes", "no" - `ship_to.instructions` (string,null) Additional text about how to handle the shipment at this address. Example: "any instruction" - `ship_to.geolocation` (array) - `ship_to.geolocation.type` (string) Enum of available type of geolocation items: - 'what3words' functionality allows to specify a location by providing 3 words that have been assign to the specific location see [link](https://what3words.com/business) for more details. Enum: "what3words" - `ship_to.geolocation.value` (string) value of the geolocation item Example: "cats.with.thumbs" ## Response 400 fields (application/json): - `request_id` (string, required) A UUID that uniquely identifies the request id. This can be given to the support team to help debug non-trivial issues that may occur Example: "aa3d8e8e-462b-4476-9618-72db7f7b7009" - `errors` (array, required) The errors associated with the failed API call - `errors.error_source` (string, required) The source of the error, as indicated by the name this informs us if the API call failed because of the carrier, the order source, or the ShipStation API itself. Enum: "carrier", "order_source", "ShipStation" - `errors.error_type` (string, required) The type of error Enum: "account_status", "business_rules", "validation", "security", "system", "integrations" - `errors.error_code` (string, required) The error code specified for the failed API Call Enum: "auto_fund_not_supported", "batch_cannot_be_modified", "carrier_conflict", "carrier_disconnected", "carrier_not_connected", "carrier_not_supported", "confirmation_not_supported", "default_warehouse_cannot_be_deleted", "field_conflict", "field_value_required", "forbidden", "identifier_conflict", "identifiers_must_match", "insufficient_funds", "invalid_address", "invalid_billing_plan", "invalid_field_value", "invalid_identifier", "invalid_status", "invalid_string_length", "label_images_not_supported", "meter_failure", "order_source_not_active", "rate_limit_exceeded", "refresh_not_supported", "request_body_required", "return_label_not_supported", "settings_not_supported", "subscription_inactive", "terms_not_accepted", "tracking_not_supported", "trial_expired", "unauthorized", "unknown", "unspecified", "verification_failure", "warehouse_conflict", "webhook_event_type_conflict", "customs_items_required", "incompatible_paired_labels", "invalid_charge_event", "invalid_object", "no_rates_returned" - `errors.message` (string, required) An error message associated with the failed API call Example: "Body of request cannot be null." - `errors.field_name` (string) The name of the field that caused the error (only present for validation errors) Example: "inventory_warehouse_id" - `errors.field_value` (string) The invalid value that was provided for the field (only present for validation errors) Example: "invalid-id" ## Response 404 fields (application/json): - `request_id` (string, required) A UUID that uniquely identifies the request id. This can be given to the support team to help debug non-trivial issues that may occur Example: "aa3d8e8e-462b-4476-9618-72db7f7b7009" - `errors` (array, required) The errors associated with the failed API call - `errors.error_source` (string, required) The source of the error, as indicated by the name this informs us if the API call failed because of the carrier, the order source, or the ShipStation API itself. Enum: "carrier", "order_source", "ShipStation" - `errors.error_type` (string, required) The type of error Enum: "account_status", "business_rules", "validation", "security", "system", "integrations" - `errors.error_code` (string, required) The error code specified for the failed API Call Enum: "auto_fund_not_supported", "batch_cannot_be_modified", "carrier_conflict", "carrier_disconnected", "carrier_not_connected", "carrier_not_supported", "confirmation_not_supported", "default_warehouse_cannot_be_deleted", "field_conflict", "field_value_required", "forbidden", "identifier_conflict", "identifiers_must_match", "insufficient_funds", "invalid_address", "invalid_billing_plan", "invalid_field_value", "invalid_identifier", "invalid_status", "invalid_string_length", "label_images_not_supported", "meter_failure", "order_source_not_active", "rate_limit_exceeded", "refresh_not_supported", "request_body_required", "return_label_not_supported", "settings_not_supported", "subscription_inactive", "terms_not_accepted", "tracking_not_supported", "trial_expired", "unauthorized", "unknown", "unspecified", "verification_failure", "warehouse_conflict", "webhook_event_type_conflict", "customs_items_required", "incompatible_paired_labels", "invalid_charge_event", "invalid_object", "no_rates_returned" - `errors.message` (string, required) An error message associated with the failed API call Example: "Body of request cannot be null." - `errors.field_name` (string) The name of the field that caused the error (only present for validation errors) Example: "inventory_warehouse_id" - `errors.field_value` (string) The invalid value that was provided for the field (only present for validation errors) Example: "invalid-id"